from flask import jsonify, render_template, request
from werkzeug.exceptions import HTTPException
from . import bp


@bp.app_errorhandler(HTTPException)
def handle_http_exception(error):
    ''' Generic HTTP exception handler '''
    accept_json = request.accept_mimetypes.accept_json
    accept_html = request.accept_mimetypes.accept_html
    if accept_json and not accept_html:
        response = jsonify(str(error))
        return response, error.code
    return render_template('errors/error.html.j2', error=error), error.code
